//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                   FileMappingMT4.mqh |
//|                                                                                                                                                   Copyright  Zhunko |
//|30.03.2010 - 16.04.2010                                                                                                                            vadim@zhunko.ru    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|    "FileMappingMT4.dll"      .                                                                      |
//|  "AIASM_Factors.dll"        "AIASM".                                                                    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|           .        ,   |
//|   .  "FileMapCreate()"  "FileMapCreateViewOfFile()"                |
//| .       "Simple"           |
//|       .  ,      ,        .          |
//|    "FileMapCreate()"   "FileMapOpen()"       ,           |
//|         "FileMapCloseHandle()".          |
//|   .      "FileMapViewOfFile()"                    |
//|  .                                                                                                                                    |
//|         (    )  1024.   |
//|     .                                                                                                   |
//|    10 .                                                                                                                                       |
//| 1.  .                                                                                                                                                    |
//| 2.              .                                           |
//| 3.         .                                                                                                          |
//| 4.                .                                    |
//| 5.         .                                                                                                        |
//| 6.                .                                   |
//| 7.       .                                                                                                               |
//| 8.              .                                         |
//| 9.       .                                                                                                             |
//|10.              .                                        |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
#import "FileMappingMT4.dll"
 //
 //    .    
 //
 //======================================================================================================================================================================
 // 1.           /       
 //         .         ,  NULL.
 //                .           
 //             .        (   
 //    ),              .       
 //     ,         .
 int FileMapCreate(int    hFileUser,    //    .
                   string sNameFileMap, //    .
                   int    nMemorySize); //      .
 //======================================================================================================================================================================
 // 2.    .         ,  NULL.    
 //                (    ),    NULL.
 int FileMapOpen(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 3.       .
 //     : 1   ;
 //                       0   ;
 //                      -1     ;
 //                      -2    ;
 //                      -3      .
 int FileMapClear(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 4.        .   TRUE   ,  FALSE.
 bool FileMapResize(string sNameFileMap, //   .
                    int    nMemorySize); //      .
 //======================================================================================================================================================================
 // 5.        .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseAll();
 //======================================================================================================================================================================
 // 6.               .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseHandleFile(int hFileUser); //    .
 //======================================================================================================================================================================
 // 7.         .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseName(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 8.       .
 //      TRUE       ,  FALSE.
 bool FileMapCloseHandle(int hFileMapping); //     .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 // 9.         /         
 //                 .      
 //            ,  NULL.
 //                .           
 //             .        (   
 //    ),              .       
 //     ,         .
 int FileMapCreateViewOfFile(int    hFileUser,    //    .
                             string sNameFileMap, //    .
                             int    nMemorySize); //      .
 //======================================================================================================================================================================
 //10.                 .
 //                  ,  NULL.    
 //                (  ),    NULL.
 int FileMapOpenViewOfFile(string sNameFileMap); //   .
 //======================================================================================================================================================================
 //11.          .
 //                  ,  NULL.
 int FileMapViewOfFile(int hMapping); //    .
 //======================================================================================================================================================================
 //12.          .
 //          TRUE  FALSE   .
 bool FileMapUnViewOfFile(int pcAddress); //          .
 //======================================================================================================================================================================
 //
 //           .    
 //
 //======================================================================================================================================================================
 //13.           BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteBool(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   BOOL     .
 //======================================================================================================================================================================
 //14.           CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteChar(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   CHAR     .
 //======================================================================================================================================================================
 //15.           UNSIGNED CHAR     .
 //        INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteUnsChar(string sNameFileMap, //   .
                         int    nStartByte,   //      ,     .
                         int    nValue);      //   UNSIGNED CHAR     .
 //======================================================================================================================================================================
 //16.           SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteShort(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       int    nValue);      //   SHORT     .
 //======================================================================================================================================================================
 //17.           UNSIGNED SHORT     .
 //        INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteUnsShort(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int    nValue);      //   UNSIGNED SHORT     .
 //======================================================================================================================================================================
 //18.           INT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteInt(string sNameFileMap, //   .
                     int    nStartByte,   //      ,     .
                     int    nValue);      //   INT     .
 //======================================================================================================================================================================
 //19.           FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteFloat(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       double dValue);      //   FLOAT     .
 //======================================================================================================================================================================
 //20.           DOUBLE     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteDouble(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        double dValue);      //   DOUBLE     .
 //======================================================================================================================================================================
 //21.              .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteString(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        string sString);     //      .
 //======================================================================================================================================================================
 //
 //                  .    
 //
 //======================================================================================================================================================================
 //22.              BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteBool(int pcAddress,  //          .
                            int nStartByte, //      ,      .
                            int nValue);    //   BOOL     .
 //======================================================================================================================================================================
 //23.              CHAR     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteChar(int pcAddress,  //          .
                            int nStartByte, //      ,      .
                            int nValue);    //   CHAR     .
 //======================================================================================================================================================================
 //24.              CHAR     .
 //         .     INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteUnsChar(int pcAddress,  //          .
                               int nStartByte, //      ,      .
                               int nValue);    //   UNSIGNED CHAR     .
 //======================================================================================================================================================================
 //25.              SHORT     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteShort(int pcAddress,  //          .
                             int nStartByte, //      ,      .
                             int nValue);    //   SHORT     .
 //======================================================================================================================================================================
 //26.              UNSIGNED SHORT     .
 //         .     INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteUnsShort(int pcAddress,  //          .
                                int nStartByte, //      ,      .
                                int nValue);    //   UNSIGNED SHORT     .
 //======================================================================================================================================================================
 //27.              INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteInt(int pcAddress,  //          .
                           int nStartByte, //      ,      .
                           int nValue);    //   INT     .
 //======================================================================================================================================================================
 //28.              FLOAT     .
 //        DOUBLE  FLOAT     .      .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteFloat(int    pcAddress,  //          .
                             int    nStartByte, //      ,      .
                             double dValue);    //   FLOAT     .
 //======================================================================================================================================================================
 //29.              DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteDouble(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              double dValue);    //   DOUBLE     .
 //======================================================================================================================================================================
 //30.                 .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteString(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              string sString);   //      .
 //======================================================================================================================================================================
 //
 //           .    
 //
 //======================================================================================================================================================================
 //31.        BOOL     .
 //         FALSE   .
 bool FileMapReadBool(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //32.        CHAR     .
 //         NULL   .
 int FileMapReadChar(string sNameFileMap, //   .
                     int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //33.        UNSIGNED CHAR     .
 //         NULL   .
 int FileMapReadUnsChar(string sNameFileMap, //   .
                        int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //34.        SHORT     .
 //         NULL   .
 int FileMapReadShort(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //35.        UNSIGNED SHORT     .
 //         NULL   .
 int FileMapReadUnsShort(string sNameFileMap, //   .
                         int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //36.        INT     .
 //         NULL   .
 int FileMapReadInt(string sNameFileMap, //   .
                    int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //37.        FLOAT     .
 //         NULL   .
 //        FLOAT     DOUBLE.
 double FileMapReadFloat(string sNameFileMap, //   .
                         int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //38.        DOUBLE     .
 //         NULL   .
 double FileMapReadDouble(string sNameFileMap, //   .
                          int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //39.           .
 //         .      NULL.
 string FileMapReadString(string sNameFileMap,   //   .
                          int    nStartByte,     //      ,     .
                          string sBuffer,        //    .
                          int    nLengthString); //      ().
 //======================================================================================================================================================================
 //
 //                  .    
 //
 //======================================================================================================================================================================
 //40.              BOOL     .
 //         .      FALSE   .
 bool FileMapSimpleReadBool(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //41.              CHAR     .
 //         .      NULL   .
 int FileMapSimpleReadChar(int pcAddress,   //          .
                           int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //42.              UNSIGNED CHAR     .
 //         .      NULL   .
 int FileMapSimpleReadUnsChar(int pcAddress,   //          .
                              int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //43.              SHORT     .
 //         .      NULL   .
 int FileMapSimpleReadShort(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //44.              UNSIGNED SHORT     .
 //         .      NULL   .
 int FileMapSimpleReadUnsShort(int pcAddress,   //          .
                               int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //45.              INT     .
 //         .      NULL   .
 int FileMapSimpleReadInt(int pcAddress,   //          .
                          int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //46.              FLOAT     .
 //         .      NULL   .
 double FileMapSimpleReadFloat(int pcAddress,   //          .
                               int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //47.              DOUBLE     .
 //         .      NULL   .
 double FileMapSimpleReadDouble(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //48.                 .
 //         .      .
 //        : "Error_1"      ;
 //                                        "Error_2"      ;
 string FileMapSimpleReadString(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //
 //         .    
 //
 //======================================================================================================================================================================
 //49.             BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteBoolArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           bool&  abArray[],    //       BOOL     .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //50.             CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteCharArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //       CHAR     .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //51.             UNSIGNED CHAR     .
 //        INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteUnsCharArray(string sNameFileMap, //   .
                              int    nStartByte,   //      ,     .
                              int&   aiArray[],    //       UNSIGNED CHAR     .
                              int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //52.             SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteShortArray(string sNameFileMap, //   .
                            int    nStartByte,   //      ,     .
                            int&   aiArray[],    //       SHORT     .
                            int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //53.             UNSIGNED SHORT     .
 //        INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteUnsShortArray(string sNameFileMap, //   .
                               int    nStartByte,   //      ,     .
                               int&   aiArray[],    //       UNSIGNED SHORT     .
                               int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //54.             INT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteIntArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //       INT     .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //55.             FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteFloatArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //       FLOAT     .
                            int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //56.             DOUBLE     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteDoubleArray(string  sNameFileMap, //   .
                             int     nStartByte,   //      ,     .
                             double& adArray[],    //       DOUBLE     .
                             int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 //57.                BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteBoolArray(int   pcAddress,   //          .
                                 int   nStartByte,  //      ,      .
                                 bool& abArray[],   //       BOOL     .
                                 int   nSizeArray); //  .
 //======================================================================================================================================================================
 //58.                CHAR     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteCharArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //       CHAR     .
                                 int  nSizeArray); //  .
 //======================================================================================================================================================================
 //59.                UNSIGNED CHAR     .
 //         .     INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteUnsCharArray(int  pcAddress,   //          .
                                    int  nStartByte,  //      ,      .
                                    int& aiArray[],   //       CHAR     .
                                    int  nSizeArray); //  .
 //======================================================================================================================================================================
 //60.                SHORT     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteShortArray(int  pcAddress,   //          .
                                  int  nStartByte,  //      ,      .
                                  int& aiArray[],   //       SHORT     .
                                  int  nSizeArray); //  .
 //======================================================================================================================================================================
 //61.                UNSIGNED SHORT     .
 //         .     INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteUnsShortArray(int  pcAddress,   //          .
                                     int  nStartByte,  //      ,      .
                                     int& aiArray[],   //       UNSIGNED SHORT     .
                                     int  nSizeArray); //  .
 //======================================================================================================================================================================
 //62.                INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteIntArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //       INT     .
                                int  nSizeArray); //  .
 //======================================================================================================================================================================
 //63.                FLOAT     .
 //         .     DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteFloatArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //       FLOAT     .
                                  int     nSizeArray); //  .
 //======================================================================================================================================================================
 //64.                DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      ;
 //                      -4    .
 int FileMapSimpleWriteDoubleArray(int     pcAddress,   //          .
                                   int     nStartByte,  //      ,      .
                                   double& adArray[],   //       DOUBLE     .
                                   int     nSizeArray); //  .
 //======================================================================================================================================================================
 //
 //        .    
 //
 //======================================================================================================================================================================
 //65.        BOOL       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadBoolArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          bool&  abArray[],    //          BOOL   .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //66.        CHAR       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadCharArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //          CHAR   .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //67.        UNSIGNED CHAR       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadUnsCharArray(string sNameFileMap, //   .
                             int    nStartByte,   //      ,     .
                             int&   aiArray[],    //          UNSIGNED CHAR   .
                             int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //68.        SHORT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadShortArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //          SHORT   .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //69.        UNSIGNED SHORT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadUnsShortArray(string sNameFileMap, //   .
                              int    nStartByte,   //      ,     .
                              int&   aiArray[],    //          UNSIGNED SHORT   .
                              int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //70.        INT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadIntArray(string sNameFileMap, //   .
                         int    nStartByte,   //      ,     .
                         int&   aiArray[],    //          INT   .
                         int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //71.        FLOAT       .
 //        FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadFloatArray(string  sNameFileMap, //   .
                           int     nStartByte,   //      ,     .
                           double& adArray[],    //          FLOAT   .
                           int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //72.        DOUBLE       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadDoubleArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //          DOUBLE   .
                            int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 //73.              BOOL       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadBoolArray(int   pcAddress,   //          .
                                int   nStartByte,  //      ,      .
                                bool& abArray[],   //          BOOL   .
                                int   nSizeArray); //  .
 //======================================================================================================================================================================
 //74.              CHAR       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadCharArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //          CHAR   .
                                int  nSizeArray); //  .
 //======================================================================================================================================================================
 //75.              UNSIGNED CHAR       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadUnsCharArray(int  pcAddress,   //          .
                                   int  nStartByte,  //      ,      .
                                   int& aiArray[],   //          UNSIGNED CHAR   .
                                   int  nSizeArray); //  .
 //======================================================================================================================================================================
 //76.              SHORT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadShortArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //          SHORT   .
                                 int  nSizeArray); //  .
 //======================================================================================================================================================================
 //77.              UNSIGNED SHORT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadUnsShortArray(int  pcAddress,   //          .
                                    int  nStartByte,  //      ,      .
                                    int& aiArray[],   //          UNSIGNED SHORT   .
                                    int  nSizeArray); //  .
 //======================================================================================================================================================================
 //78.              INT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadIntArray(int  pcAddress,   //          .
                               int  nStartByte,  //      ,      .
                               int& aiArray[],   //          INT   .
                               int  nSizeArray); //  .
 //======================================================================================================================================================================
 //79.              FLOAT       .
 //         .     FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadFloatArray(int     pcAddress,   //          .
                                 int     nStartByte,  //      ,      .
                                 double& adArray[],   //          FLOAT   .
                                 int     nSizeArray); //  .
 //======================================================================================================================================================================
 //80.              DOUBLE       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      ;
 //                       -4    .
 int FileMapSimpleReadDoubleArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //          DOUBLE   .
                                  int     nSizeArray); //  .
 //======================================================================================================================================================================
 //
#import
//

